/**
 * This file is part of SuperSimpleAI: An OpenTTD AI.
 *
 * Author: Jaume Sabater
 *
 * It's free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * any later version.
 *
 * You should have received a copy of the GNU General Public License
 * with it.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Some math functions, needed for other mylib functions.
 */
require("mymath.nut");

/**
 * These classes can extends some AI classes. Code from SimpleAI, DictatorAI, PAXLink.
 */
require("myaiairport.nut");
require("myaibridge.nut");
require("myaicargo.nut");
require("myaicompany.nut");
require("myaicontroller.nut");
require("myaiengine.nut");
require("myaigamesettings.nut");
require("myaigroup.nut");
require("myaiindustry.nut");
require("myailist.nut");
require("myaimap.nut");
require("myairail.nut");
require("myairoad.nut");
require("myaitile.nut");
require("myaitunnel.nut");
require("myaivehicle.nut");

/**
 * PathFinder Classes
 */
require("pathfinder-rail.nut");
require("pathfinder-road.nut");
require("pathfinder-utils.nut");

/**
 * Terraforming class. This file is from NoCAB version 2.1.1.
 */
require("terraform.nut");

/**
 * SetCompanyName class. This file is a contribution by 3iff to a SimpleAI project.
 */
require("setcompanyname.nut");

/**
 * Some other functions from SimpleAI, written by Brumi.
 */
require("myplanes.nut");
require("myroadvehs.nut");
require("mytrains.nut");
require("mystation.nut");

